(require deftemplates)

(set-current-module CLEANUP)

;(defrule print-module-cleanup
;    (declare (salience 100))
;    (MAIN::model (tick ?tick))
;    =>
;    (dump (str-cat "MODULE CLEANUP started")))

;; retract unneeded facts that can't be removed via disposal policy

;;---- death related -----------------------------------

(defrule retract-endorsements-of-dead-person
    (MAIN::death (name ?dead-person))
    ?f <- (MAIN::endorsed (clauseOwner ?dead-person))
    =>
    (retract ?f) 
)

(defrule retract-endorsements-to-dead-person
    (MAIN::death (name ?dead-person))
  	?f <- (MAIN::endorsed (endorsed-object ?dead-person))
	=>
    (retract ?f)
)

(defrule end-employment-of-dead-person
    (MAIN::death (tickStamp ?tick) (name ?dead-person))
    ?f <- (MAIN::employment (employee ?dead-person) (end-date ?t &: (> ?t ?tick)))
    =>
    (modify ?f (end-date ?tick))
)

(defrule remove-dead-person
    "remove person shadow fact from memory"
    (MAIN::death (name ?person))
    ?p <- (MAIN::person (name ?person))
    =>
    (dump (str-cat "REMOVE FACT OF DEAD PERSON " ?person))
    (retract ?p)
)


;;---- sexual partner related --------------------------

(defrule message-sexual-partner-request-disposal
    "get rid of all requests from this timestep"
	?m <- (message (header sexual-partner-request))
	=>
	(retract ?m)
)


;;---- mining related ----------------------------------

(defrule retract-neighbour-endorsements-of-miner
    "when the renting contract ends the neighbour endorsements have to be removed"
    (MAIN::model (tick ?tick))
    (MAIN::rent-a-shack (tenant ?miner)(end-date ?tick))
    ?f <- (MAIN::endorsed (clauseOwner ?miner)(endorsement is-neighbour))
    =>
    (retract ?f)
)

(defrule retract-neighbour-endorsements-to-miner
    "when the renting contract ends the neighbour endorsements have to be removed"
    (MAIN::model (tick ?tick))
    (MAIN::rent-a-shack (tenant ?miner)(end-date ?tick))
    ?f <- (MAIN::endorsed (endorsed-object ?miner)(endorsement is-neighbour))
    =>
    (retract ?f)
)

(defrule retract-endorsements-of-left-miner
    (MAIN::leave (miner ?left-miner))
    ?f <- (MAIN::endorsed (clauseOwner ?left-miner))
    =>
    (retract ?f) 
)

(defrule retract-endorsements-to-left-miner
    (MAIN::leave (miner ?left-miner))
  	?f <- (MAIN::endorsed (endorsed-object ?left-miner))
	=>
    (retract ?f)
)

(defrule end-shack-renting-of-left-miner
	"end the contract if miner leaves before its agreed end"
    (MAIN::leave (miner ?left-miner)(tickStamp ?tick))
    ?r <- (MAIN::rent-a-shack (tenant ?left-miner){end-date > ?tick})
	=>
    (modify ?r (end-date ?tick))
)

(defrule remove-left-miner
    "remove person shadow fact from memory"
    (MAIN::leave (miner ?left-miner))
    ?p <- (MAIN::person (name ?left-miner))
    =>
    (dump (str-cat "REMOVE FACT OF LEFT MINER " ?left-miner))
    (retract ?p)
)

(defrule message-shack-application-disposal
    "get rid of all requests from this timestep"
	?m <- (message (header shack-application))
	=>
	(retract ?m)
)

(set-current-module MAIN)

