(require deftemplates)
(require defqueries)

(set-current-module FINAL)

(defrule print-module-final
    (declare (salience 100))
    (MAIN::model (tick ?tick &: (> ?tick 150)))
    =>
    ((System.out) println (str-cat "MODULE FINAL started"))
)

;;----- death related ---------------------------------

(defrule pending-burial-payment
    "reminds hh to pay for burial in next tick"
    (MAIN::death (household ?hh)(name ?name)(tickStamp ?tick))
	=>
    (assert 
        (MAIN::death-in-hh
        	(household ?hh)
        	(deceased ?name)
            (tickStamp ?tick)))    
)

;;------ marriage related ------------------------------

(defrule pay-lobola
	"the household of the groom pays lobola to the household of the bride"
    (declare (no-loop TRUE))
;    (MAIN::model (OBJECT ?m-obj))
    (MAIN::marriage (tickStamp ?tick) (groom-household ?g-hh) (bride-household ?b-hh))
    ?h <- (MAIN::household (id ?g-hh) (spendingCommitments ?commitments) (cash ?cash) (expectedIncome ?income)(monthlyFoodCost ?food-cost)(model ?m-obj))
	=>
    (if (> ?tick 350) then
        ((System.out) println (str-cat "pay-lobola from " ?g-hh " to " ?b-hh)))
;    ((System.out) println (str-cat ?g-hh " needs to pay lobola to " ?b-hh))
    (dump (str-cat ?g-hh " needs to pay lobola to " ?b-hh))
    (bind ?lobola (call ?m-obj randomInt ?*min-lobola* ?*max-lobola*))
;    ((System.out) println (str-cat "lobola = " ?lobola ))
    (dump (str-cat "lobola = " ?lobola ))
    (bind ?lobola (min ?lobola (+ (- ?cash ?commitments) ?income)))
;    ((System.out) println (str-cat "corrected lobola = " ?lobola))
    (dump (str-cat "corrected lobola = " ?lobola))
    (modify ?h (spendingCommitments (+ ?commitments ?lobola)))
    (assert 
        (MAIN::payment
            (amount ?lobola)
            (cause marriage)
            (payer ?g-hh)
            (recipient ?b-hh)
            (payment-date ?tick)))
	(if (> ?tick 350) then
        ((System.out) println "end of rule"))    
)

(defrule pending-household-creation
    "reminds groom that he needs to build a house to move into their own household (only if not already hh head)"
    (MAIN::marriage (groom ?groom) (tickStamp ?tick))
    (MAIN::person (name ?groom) (head FALSE))
    =>
    (assert
        (MAIN::upcoming-household
        	(person ?groom)
        	(tickStamp ?tick)))
)

(defrule pay-for-new-house
;    (declare (no-loop TRUE))
;    (MAIN::model (OBJECT ?m-obj))
    (MAIN::payment (amount ?amount) (recipient ?hh) (cause new-house) (payment-date ?tick))
    ?h <- (MAIN::household (id ?hh) (spendingCommitments ?commitments)(model ?m-obj))
    (not (MAIN::payment (payer ?hh) (cause new-house)))
	=>
	(if (> ?tick 350) then
        ((System.out) println "rule pay-for-new-house for " ?hh))    
        (bind ?house-costs (- ?amount (call ?m-obj randomInt 500 900))) ;; keep 500-900 Rand as initial cash
    (modify ?h (spendingCommitments (+ ?commitments ?house-costs)))
    (assert 
        (MAIN::payment
            (amount ?house-costs)
            (payer ?hh)
            (cause new-house)
            (payment-date ?tick)))
    (dump (str-cat "payment (amount " ?house-costs ")(payer " ?hh ")(cause new-house)(payment-date " ?tick ")"))
	(if (> ?tick 350) then
        ((System.out) println "end of rule"))    
)


;;------ friendship related ----------------------------

;(defrule endorse-friends
;    "choose best endorsed of similar age/gender as friends (up to maxNumFriends)"
;;    (declare (salience -10))
;    (MAIN::person (name ?person)(maxNumFriends ?max-friends &: (> ?max-friends 0))
;        (agentEndorsementScheme ?end-scheme)(age ?age)(gender ?gender))
;    (exists (MAIN::endorsed (clauseOwner ?person) (endorsement similar)))
;    =>
;    (dump (str-cat ?person" ("?gender", "?age") chooses friends"))
;    ;; find all others endorsed as similar (= agents of correct age group and gender)
;    (bind ?tick (current-tick))
;    (bind ?potential-friends (create$))
;    (bind ?qr (run-query* MAIN::specific-endorsement-query ?person similar ?tick))
;    (while (?qr next)
;        (bind ?potential-friends (create$ ?potential-friends (?qr get endorsee)))
;    )
;    (if (> (length$ ?potential-friends) 0) then
;    	;; compute overall endorsement values for potential friends
;        (bind ?end-values (create$))
;	    (foreach ?p ?potential-friends
;	        (bind ?qr (run-query* MAIN::endorsements-query ?person ?p ?tick))
;	        (bind ?endorsements (create$))
;	        (while (?qr next)
;	         	(bind ?endorsements (create$ ?endorsements (?qr get endorsement)))
;	        )
;	        (bind ?end-values (create$ ?end-values (endorsement-value ?end-scheme ?endorsements)))
;	    )
;        ;; sort endorsement values in descending order
;	    (bind ?indices (sort-values ?end-values TRUE))
;        ;; pick the first n potential friends as friends
;        (bind ?i 1)
;        (bind ?num-left ?max-friends)
;        (bind ?friends (create$))
;        (while (and (< ?i (length$ ?indices))
;                	(> ?num-left 0))
;	    	(bind ?friend (nth$ (nth$ ?i ?indices) ?potential-friends))
;        	(assert
;                (MAIN::endorsed
;                    (clauseOwner ?person)
;                    (endorsed-object ?friend)
;                    (endorsement is-friend)
;                    (uniquifiers (nth$ (nth$ ?i ?indices) ?end-values))
;                    (tickStamp ?tick))) 
;            (-- ?num-left)
;            (++ ?i)     
;            (bind ?friends (create$ ?friends ?friend))          
;        )   
;        (dump (str-cat ?person " picked as friends: " ?friends))
;     )   
;)


(defrule potential-friends
	"best endorsed of known other agents"
;    (MAIN::model (OBJECT ?m-obj))
    (MAIN::person (name ?person)(knownPersons $?known-persons)(gender ?gender)(age ?own-age)
        (maxNumFriends ?max-friends &:(> ?max-friends 0))
        (agentEndorsementScheme ?end-scheme))
    (MAIN::endorsed (clauseOwner ?person)(endorsement similar)(endorsed-object ?other))
;    (person (gender ?gender)(age ?other-age &: (< (abs (- ?own-age ?other-age)) 8))(name ?other &: (member$ ?other ?known-persons)))
    =>
    (bind ?tick (current-tick))
    (if (> ?tick 350) then
        ((System.out) println (str-cat "rule potential-friends for " ?person)))
    (bind ?endorsements (create$))
    (bind ?qr (run-query* MAIN::endorsements-query ?person ?other ?tick))
    (while (?qr next)
        (bind ?endorsements (create$ ?endorsements (?qr get endorsement))))
    (bind ?end-val (endorsement-value ?end-scheme ?endorsements))
;    (watch facts)
    (assert
        (object-endorsement-value
            (object-type friend)
            (object ?other)
            (endorsement-value ?end-val)
            (clauseOwner ?person)
            (tickStamp ?tick)))
;    (unwatch facts)
;    (dump (str-cat ?person "(" ?gender ", " ?own-age ") evaluates " ?other " as potential friend on the basis of the following endorsements: " ?endorsements))
	(if (> ?tick 350) then
        ((System.out) println "end of rule"))    
)

(defrule make-friends
	"choose best endorsed of the known others up to maxNumFriends as friends"
    (declare (salience -10))
;    (MAIN::model (OBJECT ?m-obj))
    (MAIN::person (name ?person)(maxNumFriends ?num-friends)(age ?age)(gender ?gender))
    (exists
        (MAIN::object-endorsement-value (tickStamp ?tick)(clauseOwner ?person)(object-type friend)))
	=>
;    (dump (str-cat ?person" ("?gender", "?age") chooses friends"))
    (bind ?tick (current-tick))  ;; why isn't variable ?tick bound from the LHS exists clause??
    (if (> ?tick 350) then
        ((System.out) println (str-cat "rule make-friends for " ?person)))
    (bind ?num-friends-left ?num-friends)
    (bind ?end-values (create$))
    (bind ?potential-friends (create$))
    (bind ?qr (run-query* MAIN::object-type-endorsement-value-query ?person friend ?tick))
    (while(?qr next)
        (bind ?friend (?qr get object))
        (if (not (member$ ?friend ?potential-friends)) then
            (bind ?potential-friends (create$ ?potential-friends ?friend))
	        (bind ?end-values (create$ ?end-values (?qr get end-value)))))
;    (printout t "potential friends of "?person" are "?potential-friends crlf)
    (bind ?friends (create$))
    (while
        (and
            (> (length$ ?potential-friends) 0)
            (> ?num-friends-left 0))
        (bind ?max-value (nth$ 1 ?end-values))
        (bind ?max-n 1)
        (for (bind ?n 1)(<= ?n (length$ ?potential-friends))(++ ?n)
            (bind ?value (nth$ ?n ?end-values))
            (if (> ?value ?max-value) then
                (bind ?max-value ?value)
                (bind ?max-n ?n)))
;        (watch facts)
        (bind ?friend (nth$ ?max-n ?potential-friends))
        (assert
            (endorsed
                (endorsed-object ?friend)
                (endorsement is-friend)
                (uniquifiers ?max-value)
                (clauseOwner ?person)
                (tickStamp ?tick)))
;        (dump (str-cat ?person " endorses " ?friend " as friend (endorsement-value = " ?max-value ")"))
;        (unwatch facts)
        (bind ?potential-friends (delete$ ?potential-friends ?max-n ?max-n))
        (bind ?end-values (delete$ ?end-values ?max-n ?max-n))
        (-- ?num-friends-left)
        (bind ?friends (create$ ?friends ?friend))
        )
;    (dump (str-cat ?person " picked as friends: " ?friends))
	(if (> ?tick 350) then
        ((System.out) println "end of rule"))    
)


            
;; ------ household related ----------------------------

(defrule lend-food
    "give household asking for food some help if affordable"
;    (MAIN::model (OBJECT ?m-obj))
    ?m <- (MAIN::message (header borrow-food-request) (recipient ?hh) (sender ?sender-hh) (slot-names $?names)(slot-values $?values)(tickStamp ?tick))
    ?h <- (MAIN::household (id ?hh)(cash ?cash)(spendingCommitments ?commitments) (expectedIncome ?income) (model ?m-obj))
    ;    (MAIN::person (name ?sender) (householdID ?sender-hh))
    (not (MAIN::help-needed (household ?hh)))	;; can't give anything when asking for help ourselves
    (not (MAIN::marriage (groom-household ?hh))) ;; being able to pay lobola has priority
	=>
	(if (> ?tick 350) then
        ((System.out) println "rule lend-food for " ?hh))    
    (bind ?needed-amount (nth$ (member$ amount ?names) ?values))
    (bind ?reserve (- (+ ?cash ?income) ?commitments))
    (if (> ?reserve 0) then
        ;; give some money with a probability of 70%
        (if (call ?m-obj probabilityp 0.7) then
            (bind ?amount (call ?m-obj randomInt 10 (div ?needed-amount 2)))
            (bind ?amount (integer (min ?amount ?reserve)))
            (assert 
                (MAIN::payment
                    (amount ?amount)
                    (cause food-request)
                    (payer ?hh)
                    (recipient ?sender-hh)
                    (payment-date ?tick)))
            (modify ?h (spendingCommitments (+ ?commitments ?amount)))
            (dump (str-cat ?hh " gives " ?amount " Rand to " ?sender-hh " for food"))
         )
    )
    (retract ?m)
	(if (> ?tick 350) then
        ((System.out) println "end of rule"))    
)         


;;----------- employment related -----------------------

(defrule government-pension
	"government employees receive a pension"
	(MAIN::model (week 3)(tick ?tick))
	(MAIN::employment (employee ?employee) (employer government) (end-date ?tick))
	?p <- (MAIN::person (name ?employee) {age >= 60} (registeredForPension FALSE))
	=>
	(modify ?p (registeredForPension TRUE))
)

(defrule employment-pay
	"record payments of wages to employees"
	(MAIN::model (week 3)(tick ?tick))	;; payments are monthly --> employments are at least for a month
    (MAIN::employment (employee ?employee)(employer ?employer)(wage ?w)
    	(start-date ?s &: (<= ?s ?tick)) (end-date ?e &: (> ?e ?tick)))
    =>
    (assert
        (payment 
            (amount ?w)
            (recipient ?employee)
            (payer ?employer)
    		(cause wage)
            (payment-date ?tick)))
    ;;*;(dump (str-cat "payment (amount "?w")(recipient "?employee")(payer "?employer")(cause wage)(payment-date "?tick")"))
)

(defrule apply-for-job
	"apply for an advertised job if of the right age and without job and not from a household with government employees"
    (employees-demanded (employer ?employer) (number-demanded ?demand) (tickStamp ?tick))
    (MAIN::person (name ?name) (householdID ?hh) (alive TRUE)(atSchool FALSE) (hasAIDS FALSE)
        (migrant FALSE)(onVisit FALSE)  ;; not a migrant
        (age ?age &: (and (> ?age 16) (< ?age 60)))) ;;(knownPersons $?known &: (member$ ?employer ?known)))
    (not (MAIN::employment (employee ?name) (end-date ?end &: (> ?end ?tick))))
	(not (and (MAIN::person (name ?relative) (householdID ?hh))
			  (MAIN::employment (employee ?relative) (employer government))))
	=>
	(assert
    	(MAIN::job-application
    		(applicant ?name)
			(potential-employer ?employer)
			(tickStamp ?tick)))
)

(defrule endorse-as-reliable
    "after n jobs performed reliably endorse employee as reliable"
	(MAIN::model (tick ?tick))
	(MAIN::job-performance (employer ?employer) (employee ?employee) (num-jobs ?n &: (> ?n 3))(reliability ?r) (tickStamp ?tick))
	(MAIN::person (name ?hh-head) (householdID ?employer) (head TRUE) (OBJECT ?p-obj))
	=>
	(bind ?relative-r (/ ?r ?n))
    (if (call ?p-obj rate "reliable" ?relative-r) then
    	(assert
    		(MAIN::endorsed
    			(clauseOwner ?hh-head)
				(endorsed-object ?employee)
				(endorsement reliable)
				(tickStamp ?tick)))
;		((System.out) println (str-cat "head of " ?employer " endorses " ?employee " as reliable")) 
        ;;*;(dump (str-cat "head of " ?employer " endorses " ?employee " as reliable"))       
    )
)

(defrule endorse-as-capable
    "after n jobs performed reliably endorse employee as reliable"
	(MAIN::model (tick ?tick))
	(MAIN::job-performance (employer ?employer) (employee ?employee) (num-jobs ?n &: (> ?n 3))(capability ?c &: (> ?c 1)) (tickStamp ?tick))
	(MAIN::person (name ?hh-head) (householdID ?employer) (head TRUE) (OBJECT ?p-obj))
	=>
	(bind ?relative-c (/ ?c ?n))
	(if (call ?p-obj rate "capable" ?relative-c) then
    	(assert
    		(MAIN::endorsed
    			(clauseOwner ?hh-head)
				(endorsed-object ?employee)
				(endorsement capable)
				(tickStamp ?tick)))
;		((System.out) println (str-cat "head of " ?employer " endorses " ?employee " as capable"))
        ;;*;(dump (str-cat "head of " ?employer " endorses " ?employee " as capable"))
    )
)

(defrule endorse-as-unreliable
    "after n jobs performed non-reliably endorse employee as unreliable"
	(MAIN::model (tick ?tick))
	(MAIN::job-performance (employer ?employer) (employee ?employee) (num-jobs ?n &: (> ?n 5))(reliability ?r) (tickStamp ?tick))
	(MAIN::person (name ?hh-head) (householdID ?employer) (head TRUE) (OBJECT ?p-obj))
	=>
	(bind ?relative-r (- 1 (/ ?r ?n)))
    (if (call ?p-obj rate "unreliable" ?relative-r) then
    	(assert
    		(MAIN::endorsed
    			(clauseOwner ?hh-head)
				(endorsed-object ?employee)
				(endorsement unreliable)
				(tickStamp ?tick)))
;		((System.out) println (str-cat "head of " ?employer " endorses " ?employee " as unreliable"))     
        ;;*;(dump (str-cat "head of " ?employer " endorses " ?employee " as unreliable"))   
    )
)

(defrule endorse-as-incapable
    "after n jobs performed non-capably endorse employee as incapable"
	(MAIN::model (tick ?tick))
	(MAIN::job-performance (employer ?employer) (employee ?employee) (num-jobs ?n &: (> ?n 5))(capability ?c) (tickStamp ?tick))
	(MAIN::person (name ?hh-head) (householdID ?employer) (head TRUE) (OBJECT ?p-obj))
	=>
	(bind ?relative-c (- 1 (/ ?c ?n)))
    (if (call ?p-obj rate "incapable" ?relative-c) then
    	(assert
    		(MAIN::endorsed
    			(clauseOwner ?hh-head)
				(endorsed-object ?employee)
				(endorsement incapable)
				(tickStamp ?tick)))
;		((System.out) println (str-cat "head of " ?employer " endorses " ?employee " as incapable" ))  
        ;;*;(dump (str-cat "head of " ?employer " endorses " ?employee " as incapable" ))      
    )
)

(defrule endorse-same-work
    "endorse co-worker (same employer during an overlapping interval)"
	(MAIN::employment (employer ?employer) (employee ?employee) (start-date ?tick))
	(MAIN::employment (employer ?employer) (employee ?co-worker &: (neq ?employee ?co-worker)) {end-date > ?tick})
    (not (MAIN::endorsed (clauseOwner ?employee) (endorsed-object ?co-worker) (endorsement same-work) (tickStamp ?tick)))
    (MAIN::person (name ?employee) (OBJECT ?employee-obj))
    (MAIN::person (name ?co-worker) (OBJECT ?co-worker-obj))
    =>
	(assert
    	(endorsed 
    		(clauseOwner ?employee)
			(endorsed-object ?co-worker)
			(endorsement same-work)
			(tickStamp ?tick)))
	(assert
    	(endorsed 
    		(clauseOwner ?co-worker)
			(endorsed-object ?employee)
			(endorsement same-work)
			(tickStamp ?tick)))
	;; also add co-worker as known person
	(call ?employee-obj addKnownPerson ?co-worker)
	(call ?co-worker-obj addKnownPerson ?employee)
)


;;----- group related ----------------------------------

(defrule propose-group
    "propose to start a new group (burial society/stokvel) to friends"
	(MAIN::group-wanted (tickStamp ?tick) (type ?type) (person ?name))
	(MAIN::model (tick ?tick))
    	=>
	(bind ?proposees (create$))
	(bind ?qr (run-query* MAIN::specific-endorsement-query ?name is-friend ?tick))
	(while (?qr next)
    	(bind ?proposees (create$ ?proposees (?qr get endorsee)))
	)
;	(printout t ?name " proposes to form a " ?type " to " (length$ ?proposees) " friends" crlf)
	(foreach ?p ?proposees
    	(assert
    		(MAIN::group-proposal
    			(type ?type)
				(proposed-by ?name)
				(proposed-to ?p)
				(tickStamp ?tick))))
)


;; ----- sexual partner related ------------------------

(defrule break-up-with-migrant
    "people going on migration have to break up with all of their current partners"
    (declare (no-loop TRUE))
    (MAIN::person (name ?migrant)(migrant TRUE)(currentPartners  $?partners &: (> (length$ ?partners) 0))
        (model ?m-obj)(OBJECT ?p-obj))
    =>
    ;; break up with all current sexual partners
    (foreach ?partner ?partners
        (bind ?qr (run-query* MAIN::person-object-query ?partner))
        (while (?qr next) (bind ?partner-obj (?qr get object)))
        (call ?partner-obj removeCurrentPartner ?p-obj)
        (dump (str-cat ?migrant " breaks up with " ?partner " due to migration"))
    )
    (call ?p-obj removeCurrentPartners)
)

;; ---- mining related ---------------------------------

(defrule pick-tenant-for-shack
	"a household picks a tenant to rent their shack"
    ?m <- (MAIN::message (header shack-for-rent)(sender ?hh)(slot-names $?slots)(slot-values $?values))
    (MAIN::household (id ?hh)(model ?m-obj)(OBJECT ?hh-obj))
    (exists (MAIN::message (header shack-application)(recipient ?hh)))
	=>
    (bind ?tick (current-tick))
;    (dump (str-cat ?hh " picks a tenant"))
    ;; retrieve proposed rent
    (bind ?rent (nth$ (member$ rent ?slots) ?values))
	;; retrieve all applicants
    (bind ?qr (run-query* MAIN::messages-query ?hh shack-application ?tick))
    (bind ?applicants (create$))
    (bind ?end-dates (create$))
    (while (?qr next)
        (bind ?applicants (create$ ?applicants (?qr get sender)))
        (bind ?end-dates (create$ ?end-dates (first$ (?qr get slot-values))))
    )
	(if (> (length$ ?applicants) 0) then
    	;; pick a random one? Pick the one who'd stay longest?
        (bind ?tenant (random-element-of ?applicants))
        (bind ?end-tick (nth$ (member$ ?tenant ?applicants) ?end-dates))
        (assert
            (MAIN::rent-a-shack
            	(landlord ?hh)
        		(tenant ?tenant)
                (rent ?rent)
        		(start-date (+ ?tick 1))
            	(end-date ?end-tick)))
		(dump (str-cat ?hh " rents a shack to " ?tenant " for a monthly rent of " ?rent " until " ?end-tick))
        ;; assert neighbour endorsements for/to miner
        (bind ?qr (run-query* MAIN::person-object-query ?tenant))
        (bind ?tenant-obj nil)
        (while (?qr next)
            (bind ?tenant-obj (?qr get object)))
        (call ?m-obj endorseNeighbours ?tenant-obj ?hh-obj)
        ;; retract shack advert
        (retract ?m)
    )
)

(defrule pay-rent
	"at the beginning of a month a miner pays rent to the landlord household for his shack"
    (MAIN::model (week 0)(tick ?tick))
    (MAIN::rent-a-shack (tenant ?miner)(landlord ?hh)(rent ?rent)
        {start-date >= ?tick}(end-date ?end-tick &: (> ?end-tick ?tick)))
	=>
    (assert
        (MAIN::payment
            (amount ?rent)
            (cause rent)
            (payer ?miner)
            (recipient ?hh)
            (payment-date ?tick)))
    (dump (str-cat ?miner " pays rent of " ?rent " to " ?hh))
)


(set-current-module MAIN)