package org.cfpm.caves.za;

import jess.*;
import uchicago.src.sim.util.Random;

/** This class implements a user function in Jess.
 *  The function "random-element-of" expects a list as parameter
 *  and returns a randomly picked element of this list.
 * 
 * @author Ruth
 *
 */
public class RandomListElement implements Userfunction {

	/** returns the name of the function in Jess */	
	public String getName(){
		return "random-element-of";
	}

	/**
	 * The argument of the call is the list of which a random element is to be picked.
	 * 
	 * @see jess.Userfunction#call(jess.ValueVector, jess.Context)
	 * @param vv -- the ValueVector containing the header and parameters
	 * @param context -- the context of the Rete engine
	 * @return random element of the list
	 */
	public Value call(ValueVector vv, Context context) throws JessException{
		ValueVector jessList = vv.get(1).listValue(context);
		Value result = jessList.get(Random.uniform.nextIntFromTo(0, jessList.size()-1));
		return result;
	}
	
}
