
package org.cfpm.caves.za;


import java.util.Comparator;
import java.util.ArrayList;
import java.util.Collections;

import cern.jet.random.*;
import cern.jet.random.engine.MersenneTwister;
import cern.jet.random.engine.RandomEngine;
import flanagan.math.PsRandom;
/**
 * @author Ruth
 *
 */
public class Test {
	
	static double mu = 0;
	static double sigma = 9.0;
	static double gamma = 5.0;
	
	public class TestPerson{
		int mineExperience = 0;
		int age = 0;
		public TestPerson(int mineExperience, int age){
			this.mineExperience = mineExperience;
			this.age = age;
		}
		public int getMineExperience(){
			return mineExperience;
		}
		public int getAge(){
			return age;
		}
		public String toString(){
			return ("(" + age + ", " + mineExperience + ")");
		}
	}

	public class ExperienceComparator implements Comparator<TestPerson> {
		
		/** compares two persons' mining experiences. Note that if this comparator
		 * returns 0 the mining experiences of the two persons are equal -- it doesn't
		 * necessarily mean that the two persons are equal (one and the same).
		 * 
		 * @param o1 the first object to be compared (must be of class Person)
		 * @param o2 the second object to be compared (must be of class Person)
		 * @return 1, 0 or -1 if o1's mining experience is lower, equal or greater
		 * than o2's mining experience.
		 */
		public int compare (TestPerson o1, TestPerson o2){
			int exp1 = ((TestPerson)o1).getMineExperience();
			int exp2 = ((TestPerson)o2).getMineExperience();
			if (exp1 > exp2) return -1;
			if (exp2 > exp1) return 1;
			return 0;
		}
	}
	
	public class AgeComparator implements Comparator<TestPerson>{
		
		public int compare (TestPerson o1, TestPerson o2){
			int age1 = o1.getAge();
			int age2 = o2.getAge();
			if (age1 > age2) return 1;
			if (age2 > age1) return -1;
			return 0;
		}
	}
	
	public void sort(){
		ArrayList<TestPerson> list = new ArrayList<TestPerson>();
		// create some test persons
		Normal expDist = new Normal(3*48, 2*48, new MersenneTwister());
		Normal ageDist = new Normal(29, 10, new MersenneTwister(123456));
		for (int i = 0; i < 10; i++){
			list.add(new TestPerson(expDist.nextInt(), ageDist.nextInt()));
		}
		// list before sort:
		print(list);
		Collections.sort(list, new ExperienceComparator());
		// list after sort
		System.out.println("-------- list sorted according to experience:");
		print(list);
		// list after sort
		Collections.sort(list, new AgeComparator());
		System.out.println("-------- list sorted according to age:");
		print(list);
	}
	
	void print(ArrayList<TestPerson> list){
		for (TestPerson p : list){
			System.out.print(p.toString() + " ");
		}
		System.out.println();
	}


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		PsRandom ageDist = new PsRandom();
		double mu = 27;
		double sigma = 2.0;
		for (int i = 0; i < 30; i++){
			System.out.println((int)(ageDist.nextLogNormal(mu, sigma)/48));
		}
		
//		Test myTest = new Test();
//		myTest.sort();
		
//		double mean = 29;
//		double sd = 7;
//		Normal ageDist = new Normal(mean, sd, new MersenneTwister(12345));
//		System.out.println("with nextInt()");
//		for (int i = 0; i < 10; i++){
//			System.out.println(ageDist.nextInt());
//		}
//		System.out.println("with nextDouble()");
//		for (int i = 0; i < 10; i++){
//			System.out.println(ageDist.nextDouble());
//		}
		
		
//		double lambda = 0.1;
//		Exponential arrivaldist = new Exponential(lambda, new MersenneTwister(123));
//		System.out.println("lambda = " + lambda);
//		System.out.println("with nextInt()");
//		for (int i = 0; i < 10; i++){
//			System.out.println(arrivaldist.nextInt());
//		}
//		System.out.println("with nextDouble()");
//		for (int i = 0; i < 10; i++){
//			System.out.println(arrivaldist.nextDouble());
//		}
		
//			class EmpiricalDiscreteDist{
//				RandomEngine randomGenerator;
//				double[] probabilities;
//				
//				public EmpiricalDiscreteDist(double[] probabilities, RandomEngine randomGenerator){
//					this.randomGenerator = randomGenerator;
//					this.probabilities = new double[probabilities.length]; 
//					// turn probs into cumulative probs
//					this.probabilities[0] = probabilities[0];
//					for (int i = 1; i < probabilities.length; i++){
//						this.probabilities[i] = this.probabilities[i-1] + probabilities[i]; 
//					}			
//					// needs to check that all the probs add up to 1
//					// for now, let's just assume it's correct
//				}
//				
//				/** returns a new sample, i.e. index value between 0 and n-1 */
//				public int nextInt(){
//					int index = 0;
//					double randomNumber = randomGenerator.nextDouble();
//					while (index < this.probabilities.length && randomNumber > this.probabilities[index]){
//						index++;
//					}
//					return index;
//				}
//			}
//		// assign clinical stage of HIV infection according to following distribution (adapted from Wawer et al.)
//		// durations are 1: 3 months, 2: 12 months, 3: 96 months, 4: 14 months 
//		// => probabilities 0.024, 0.096, 0.768, 0.112
//		EmpiricalDiscreteDist stageDist = new EmpiricalDiscreteDist(new double[]{0.0, 0.024, 0.096, 0.768, 0.112}, new MersenneTwister(123));
//		// use Weibull distribution with parameters mu = 0, sigma = 9.0, gamma = 5.0 (years)
//		PsRandom progressionDist = new PsRandom();
//		System.out.println("duration to AIDS with Weibull dist:");
//		for (int i = 0; i < 50; i++){
//			int currentStage = /*Math.min(*/stageDist.nextInt()/*,3)*/;
//			System.out.print("stage = " + currentStage);
//			int durationToAIDS = (int)(progressionDist.nextWeibull(mu, sigma, gamma)*12*4);
//			if (currentStage == 2) durationToAIDS -= 3*4;
//			if (currentStage == 3) durationToAIDS -= 15*4;
//			if (currentStage == 4) durationToAIDS = 0;
//
//			System.out.println(" duration to AIDS = " + durationToAIDS);
//		}
//		
//
	}

}
