/**
 * 
 */
package org.cfpm.caves.za.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

/**
 * @author Ruth
 *
 */
public class TraceSplitter {

	static String inputPath = "/data/experiments/southAfricaModel/run-1206486794099/";
	static String outputPath = inputPath + "trace/";
	static String inputFileName = "trace.txt";
	static String outputFileName = "t-";

	public static void splitFile(File traceFile) throws IOException {
		System.out.println("start processing file " + traceFile.getName());
		// open file input stream
		FileInputStream fileIn = new FileInputStream(traceFile);
		BufferedReader bufferIn = new BufferedReader(new InputStreamReader(fileIn));
		// create output directory
		File temp = new File(outputPath);
		if (!temp.exists()){
			if (temp.mkdir()){
				System.out.println("OUTPUT directory created");
			}
			else {
				System.out.println("FAILED to create OUTPUT directory");
			}
		}
		else {
			System.out.println("OUTPUT directory exists already");
		}
		// read in big trace file and split it into separate files
		
		int i = 0;
		
		while(bufferIn.ready()){
			int row = 0;
			// create output file
			File outputFile = new File(outputPath + outputFileName + i + ".txt");
			PrintWriter printOut = new PrintWriter(new FileWriter(outputFile));
			System.out.println("write trace file " + outputFile.getName());
			// write 50,000 lines to output file 
			while (row < 50000 && bufferIn.ready()){
				String fileLine = bufferIn.readLine();
				row++;
				printOut.println(fileLine);
			}
			printOut.flush();
			printOut.close();
			i++;
		}
		// close file input stream
		bufferIn.close();
		fileIn.close();
		System.out.println("done");
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		File in = new File(inputPath + inputFileName);
		try {
			splitFile(in);
		}
		catch (IOException e){
			System.out.println("IOException!");
			e.printStackTrace();
		}

	}

}
