(require deftemplates)
(require defqueries)

;; rules no longer in use 

;; ----------------- init

;(defrule report-date
;	"test whether setDate method working correctly"
;	(model (tick ?tick)(year ?year)(month ?month)(week ?week))
;    =>
;    (printout t "At tick "?tick", the date(y/m/w) is "?year"/"?month"/"?week crlf)
;)


;; -------- tag related rules -------------------------

;(defrule child-similarity-identification
;	"identify similar children"
;;    (MAIN::model (OBJECT ?m-obj))
;    (MAIN::person (name ?person)(gender ?gender)(knownPersons $?known-persons)
;        (age ?own-age &: (< ?own-age 12))
;        (tag $?own-tag))
;    (MAIN::person (gender ?gender)(name ?other &: (member$ ?other ?known-persons))
;        (age ?other-age &:(< (abs (- ?own-age ?other-age)) 3))
;        (tag $?other-tag))
;    =>
;    (bind ?similarity (number-of-common-attributes ?own-tag ?other-tag))
;;   (watch facts)
;    (assert
;        (similarity-index 
;            (other-person ?other)
;            (similarity ?similarity)
;            (clauseOwner ?person)
;            (tickStamp (current-tick))))
;;    (unwatch facts)
;)

;(defrule adult-similarity-identification
;	"identify others with most similar and similar tags"
;;    (MAIN::model (OBJECT ?m-obj))
;    (MAIN::person (tag $?own-tag)(name ?person)(gender ?gender)(knownPersons $?known-persons)(age ?own-age &: (> ?own-age 12)))
;	(MAIN::person
;        (name ?other &: (member$ ?other ?known-persons))
;        (gender ?gender)
;        (age ?other-age 
;            &:(and
;                (> ?other-age 12)
;                (< (abs (- ?own-age ?other-age)) 8)))
;        (tag $?other-tag))
;    (not
;        (MAIN::similarity-index (clauseOwner ?person)(other-person ?other)))
;    =>
;    (bind ?similarity (number-of-common-attributes ?own-tag ?other-tag))
;;    (watch facts)
;    (assert
;        (similarity-index 
;            (other-person ?other)
;            (similarity ?similarity)
;            (clauseOwner ?person)
;            (tickStamp (current-tick))))
;;    (unwatch facts)
;)

;(defrule watch-activations
;    (MAIN::model (tick 5))
;    =>
;    (watch rules))
;
;(defrule unwatch-activations
;    (MAIN::model (tick 80))
;    =>
;    (unwatch rules))


(defrule evolve-tag  ;; --> moved to Java
	"evolve tags preferentially towards those of best endorsed friends"
    (MAIN::model (tick ?tick)(OBJECT ?model))
	(MAIN::friends-list (friends $?friends)(endorsement-values $?end-values)
        (clauseOwner ?person)(tickStamp =(- ?tick 1)))
    =>
    (bind ?max 0)
    (bind ?max-n (create$))
    (for (bind ?n 1)(<= ?n (length$ ?friends))(++ ?n)
        (bind ?val (nth$ ?n ?end-values))
        (if (> ?val ?max)
            then
            (bind ?max ?val)
            (bind ?max-n (create$ ?n))
            else
            (if (= ?val ?max)
                then
                (bind ?max-n (create$ ?max-n ?n)))))
    (foreach ?n ?max-n
;        (printout t "the evolve-tags args are "?person", "(nth$ ?n ?friends)" and "?model crlf)
        (evolve-tag ?person (nth$ ?n ?friends) ?model))
    )

(defrule endorse-kin	;; --> moved to Java
	"take from kinship link"
	(MAIN::link (type "kinship")(fromID ?from)(toID ?to))
    (MAIN::household (id ?from)(memberIDs $?from-members))
    (MAIN::household (id ?to)(memberIDs $?to-members))
    (MAIN::model (tick 0))
    =>
;    (watch facts)
    (foreach ?from-member ?from-members
        (foreach ?to-member ?to-members
            (assert
                (endorsed
                    (endorsed-object ?to-member)
                    (endorsement is-kin)
                    (clauseOwner ?from-member)
                    (tickStamp 0)))))
;    (unwatch facts)
)

;(defrule pay-off-grace-period-debt
;	"if there's enough cash again pay off the debt"
;    (MAIN::model (tick ?tick) (week 0))
;    (MAIN::person (name ?member) (householdID ?hh) (OBJECT ?p-obj))
;    (MAIN::burialSociety (name ?bs)(memberIDs $?member-list &: (member$ ?member $?member-list)) 
;        (monthlyFee ?fee) (membersOnGrace $?members-on-grace &: (member$ ?member $?members-on-grace)) 
;    	(gracePeriods $?grace-periods)(OBJECT ?bs-obj))
;    (MAIN::household (id ?hh) (cash ?cash &: (> ?cash (* ?fee (- ?tick (nth$ (member$ ?member $?members-on-grace) $?grace-periods)))))  
;
;;; strangely enough, this doesn't work because the member$ function in the household clause may return FALSE
;;; causing an execption in the nth$ function
;;; WHY? I thought the patterns would be evaluated from the top down, making sure that member$ returns a number, i.e.
;;; that only members on grace are actually matched!       
;
;    =>
;    (bind ?amount (* ?fee (nth$ (member$ ?member $?members-on-grace) $?grace-periods)))
;    (printout t ?member " pays off grace period debt of " ?amount " Rand to " ?bs crlf)
;    (call ?bs-obj payIn ?p-obj ?amount)
;    (assert
;        (MAIN::payment
;        	(payer ?member)
;    		(recipient ?bs)
;            (cause fee)
;            (payment-date ?tick)
;            (amount ?amount)		
;    ))
;)

(defrule leave-burial-society
	"after being on grace period for a while leave society if still not able to afford it"
    (MAIN::model (tick ?tick) (week 0))
    (MAIN::person (name ?member) (householdID ?hh) (OBJECT ?p-obj))
    (MAIN::burialSociety (name ?bs)(memberIDs $?member-list &: (member$ ?member $?member-list)) 
        (monthlyFee ?fee) (membersOnGrace $?members-on-grace &: (member$ ?member $?members-on-grace)) 
    	(gracePeriods $?grace-periods &: (> (nth$ (member$ ?member $?members-on-grace) $?grace-periods) 5))(OBJECT ?bs-obj))
    (MAIN::household (id ?hh) (cash ?cash &: (<= ?cash (* ?fee (- ?tick (nth$ (member$ ?member $?members-on-grace) $?grace-periods))))))                  
    =>
    (printout t ?member " leaves " ?bs " due to lack of money")
    (call ?bs-obj removeMember ?p-obj)
)

;(defrule count-group-interests
;    (MAIN::model (tick ?tick))
;    ?c <- (accumulate
;        (bind ?count 0)
;    	(bind ?count (+ ?count 1))
;    	?count
;    	(MAIN::group-wanted
;        	(tickStamp =(- ?tick 1))
;    		(type burial-society)
;    		(person ?name)))
;    =>
;    (printout t ?c " people want to start a burial society <<<<<<<" crlf)
;)


;(defrule desire-for-stokvel
;	"if income sufficient to cover food, then look for stokvel"
;    (MAIN::person 
;        (head TRUE)
;        (age ?age &: (< 24 ?age 50))
;        (name ?person)(householdID ?hh))
;    (not
;        (MAIN::is-member-of (group-type stokvel)(member ?person)))
;	(MAIN::household (id ?hh) (monthlyFoodCost ?food-cost) (expectedIncome ?income)) ; &: (> ?income ?food-cost)))
;    (MAIN::model (tick ?tick))
;    =>
;    (printout t "Monthly food cost of "?hh" is "?food-cost"; income is "?income crlf)
;    (watch facts)
;    (assert
;        (stokvel-wanted (person ?person)(tickStamp ?tick)))
;    (unwatch facts)
;)
;
;(defrule form-circle-of-neighbour-friends
;	"neighbours who are friends are candidates for creating a stokvel"
;	(person (head TRUE)(householdID ?hhold)(name ?name)(gender ?gender))
;    (MAIN::endorsed (clauseOwner ?name)(endorsement is-friend)(endorsed-object ?friend))
;    (person (name ?friend)(head TRUE)(gender ?gender)(householdID ?friend-hhold))
;    (model (tick ?tick))
;    =>
;;    (printout t ?name" is a friend of "?friend" at tick "?tick crlf)
;    (assert
;        (stokvel-proposal 
;            (proposed-by ?name)
;            (proposed-to ?friend)
;            (tickStamp ?tick)))
;)
;

;(defrule occasional-employment-after-food-payment
;	"if sufficiently rich, hire one person with probability of 0.15 in any week"
;	(MAIN::model (tick ?tick)(standardWage ?w)(OBJECT ?model))
;	(MAIN::household (id ?employer) (cash ?cash))
;    (MAIN::payment (payment-date ?tick)(payer ?employer)(cause food)(amount ?food-payment))
;    =>
;    (bind ?available-for-hiring (- ?cash ?food-payment))
;    (bind ?max-employees (div ?available-for-hiring ?w))
;    (bind ?demand 0)
;    (for (bind ?i 0)(< ?i ?max-employees)(++ ?i)
;        (if (?model probabilityp 0.15) then
;            (++ ?demand)))
;    (if (> ?demand 0) then
;;       (watch facts)
;	    (assert
;	        (employees-demanded
;	            (household ?employer)
;	            (number-demanded ?demand)
;	            (tickStamp ?tick)))
;;	    (unwatch facts)
;        ))
;
;(defrule occasional-employment-with-no-food-payment
;	"if sufficiently rich, hire one person with probability of 0.15 in any week"
;	(MAIN::model (tick ?tick)(standardWage ?w)(OBJECT ?model))
;	(MAIN::household (id ?employer) (cash ?cash))
;    (not
;        (MAIN::payment (payment-date ?tick)(payer ?employer)(cause food)(amount ?food-payment)))    
;    =>
;    (bind ?max-employees (div ?cash ?w))
;    (bind ?demand 0)
;    (for (bind ?i 0)(< ?i ?max-employees)(++ ?i)
;        (if (?model probabilityp 0.15) then
;            (++ ?demand)))
;    (if (> ?demand 0) then
;;       (watch facts)
;	    (assert
;	        (employees-demanded
;	            (household ?employer)
;	            (number-demanded ?demand)
;	            (tickStamp ?tick)))
;;	    (unwatch facts)
;    )
;)



;(defrule test-incomes
;	(MAIN::household (id ?hh)(memberIDs $?members)(cash ?cash)(expectedIncome ?income))
;    ?num-children <-(accumulate
;        (bind ?num 0)
;        (++ ?num)
;        ?num
;        (MAIN::person (householdID ?hh)(age ?age &: (< ?age 7))))
;    ?num-pensioners <-(accumulate
;        (bind ?num 0)
;        (++ ?num)
;        ?num
;        (MAIN::person (householdID ?hh)(registeredForPension TRUE)))
;    =>
;    (if (> ?num-children 0) then
;        (printout t ?hh" has "?num-children" children" crlf))
;    (if (> ?num-pensioners 0) then
;        (printout t ?hh" has "?num-pensioners" registered pensioners" crlf))
;    (printout t "The expected income of "?hh" is "?income crlf)
;    (printout t ?hh"'s cash holdings are "?cash crlf crlf)
;    )



;; ----------------- content

/*
(defrule similarity-endorsement
	"endorse others with positive similarity indices"
    (MAIN::model (tick ?tick))
    (MAIN::known-similarities (tickStamp ?tick)(clauseOwner ?person)
        (other-persons $?others)(similarity-indices $?sim-indices))
	=>
;    (watch facts)
    (for (bind ?i 1)(<= ?i (length$ ?others))(++ ?i)
        (bind ?index (nth$ ?i ?sim-indices))
        (if (> ?index 0) then
            (assert
                (endorsed 
                    (endorsed-object (nth$ ?i ?others))
                    (endorsement similar)
                    (uniquifiers (create$ ?index))
                    (clauseOwner ?person)
                    (tickStamp ?tick)))))
;    (unwatch facts)
    )
*/

;(defrule create-draft-stokvel
;    "see how close proposed membership is for all proposers"
;    (MAIN::model (tick ?tick))
;    (MAIN::stokvel-wanted (tickStamp ?tick)(person ?person))
;    ?proposers <- (accumulate
;        (bind ?list (create$))
;        (bind ?list (create$ ?list ?proposer))
;        ?list
;        (MAIN::stokvel-proposal
;            (tickStamp ?tick)
;            (proposed-to ?person)
;            (proposed-by ?proposer)))
;    =>
;    (printout t "Stokvel proposed to "?person" by "?proposers crlf)
;    )



;; ----------------- final

/*(defrule add-values-to-friends-list
	"modify the fact"
    (MAIN::model (tick ?tick))
    ?friends-fact <- (MAIN::friends-list (endorsement-values )(friends $?friends)
        (clauseOwner ?person)(tickStamp ?tick))
    (MAIN::person (name ?person)(agentEndorsementScheme ?end-scheme))
	=>
    (bind ?end-values (create$))
    (foreach ?friend ?friends
        (bind ?endorsements (create$))
        (bind ?qr (run-query* MAIN::endorsements-query ?person ?friend ?tick))
        (while (?qr next)
            (bind ?endorsements (create$ ?endorsements (?qr get endorsement))))
        (bind ?end-values (create$ ?end-values (endorsement-value ?end-scheme ?endorsements))))
;    (watch facts)
    (modify ?friends-fact (endorsement-values ?end-values))
;    (unwatch facts)
    )
*/

(defrule create-friends-list
	"start with least well endorsed friends"
	(MAIN::person (name ?person)(agentEndorsementScheme ?end-scheme))
    (MAIN::model (tick ?tick))
    (exists
        (MAIN::endorsed (clauseOwner ?person)(tickStamp ?tick)
            (endorsement is-friend)))
    =>
    (bind ?friends (create$))
    (bind ?friend-qr (run-query* MAIN::specific-endorsement-query ?person is-friend ?tick))
    (while (?friend-qr next)
        (bind ?friend (?friend-qr get endorsee))	
        (bind ?friends (create$ ?friends ?friend)))
        (bind ?end-values (create$))
    (foreach ?friend ?friends
        (bind ?endorsements (create$))
        (bind ?qr (run-query* MAIN::endorsements-query ?person ?friend ?tick))
        (while (?qr next)
            (bind ?endorsements (create$ ?endorsements (?qr get endorsement))))
        (bind ?end-values (create$ ?end-values (endorsement-value ?end-scheme ?endorsements))))
;    (watch facts)
    (assert
        (friends-list
            (friends ?friends)
            (endorsement-values ?end-values)
            (clauseOwner ?person)
            (tickStamp ?tick)))
;    (unwatch facts)
    )

